diff --git a/src/smallmap_gui.cpp b/src/smallmap_gui.cpp
--- a/src/smallmap_gui.cpp
+++ b/src/smallmap_gui.cpp
@@ -277,10 +692,308 @@
 	MKCOLOUR_XXXX(0x67),
 	MKCOLOUR_XXXX(0x67),
 };
-assert_compile(lengthof(_dark_green_map_heights) == MAX_TILE_HEIGHT + 1);
-
-/** Height map colours for the violet colour scheme, ordered by height. */
-static const uint32 _violet_map_heights[] = {
+assert_compile(lengthof(_dark_green_map_heights_old) == MAX_TILE_HEIGHT_OLD + 2);
+
+/**
+ * Height map colours for the dark green colour scheme, ordered by height.
+ * Used when AllowMoreHeightlevels() is true.
+ * For the moment the aray is extended to 256 levels.
+ */
+static const uint32 _dark_green_map_heights_extended[] = {
+	/* First two colours are action colours.(First commented out, first we need level -1 (and underwater tunnels)) */
+	//MKCOLOUR(0xdcdcdcdc), // Nice flashy colour, darkblue. (Do not use above level 1. (second colour)) (I keep it here to become level -1 ground tile (not flooded) (For now: To see its full effect, use this as second color.Then imagine at level -1.))
+	MKCOLOUR(0x04dcdcdc), // Action colour, flashing purple. This is for level zero(Not flooded) !! Flooding danger !! Not yet water. (When level -1 will be possible: Will provide for a nice flooding_danger_area_border_flash in combination witch previous colour, similar to the waves at water borders.)
+	MKCOLOUR(0x60606060), // height 1 // original smallmap color do not modify
+	MKCOLOUR(0x60606060),
+	MKCOLOUR(0x60606061), // height 3
+	MKCOLOUR(0x60606061),
+	MKCOLOUR(0x60606160), // height 5
+	MKCOLOUR(0x60606160),
+	MKCOLOUR(0x60606161), // height 7
+	MKCOLOUR(0x60606161),
+	MKCOLOUR(0x60616060), // height 9
+	MKCOLOUR(0x60616060),
+	MKCOLOUR(0x60616061), // height 11 // original smallmap color do not modify
+	MKCOLOUR(0x60616061),
+	MKCOLOUR(0x60616160), // height 13
+	MKCOLOUR(0x60616160),
+	MKCOLOUR(0x60616161), // height 15
+	MKCOLOUR(0x60616161),
+	MKCOLOUR(0x61606060), // height 17
+	MKCOLOUR(0x61606060),
+	MKCOLOUR(0x61606061), // height 19
+	MKCOLOUR(0x61606061),
+	MKCOLOUR(0x61606160), // height 21
+	MKCOLOUR(0x61606160),
+	MKCOLOUR(0x61606161), // height 23
+	MKCOLOUR(0x61606161),
+	MKCOLOUR(0x61616060), // height 25
+	MKCOLOUR(0x61616060),
+	MKCOLOUR(0x61616061), // height 27
+	MKCOLOUR(0x61616061),
+	MKCOLOUR(0x61616160), // height 29
+	MKCOLOUR(0x61616160),
+	MKCOLOUR(0x61616161), // height 31 // original smallmap color do not modify
+	MKCOLOUR(0x61616161),
+	MKCOLOUR(0x61616162), // height 33
+	MKCOLOUR(0x61616162),
+	MKCOLOUR(0x61616261), // height 35
+	MKCOLOUR(0x61616261),
+	MKCOLOUR(0x61616262), // height 37
+	MKCOLOUR(0x61616262),
+	MKCOLOUR(0x61626161), // height 39
+	MKCOLOUR(0x61626161),
+	MKCOLOUR(0x61626162), // height 41 // original smallmap color do not modify
+	MKCOLOUR(0x61626162),
+	MKCOLOUR(0x61626261), // height 43
+	MKCOLOUR(0x61626261),
+	MKCOLOUR(0x61626262), // height 45
+	MKCOLOUR(0x61626262),
+	MKCOLOUR(0x62616161), // height 47
+	MKCOLOUR(0x62616161),
+	MKCOLOUR(0x62616162), // height 49
+	MKCOLOUR(0x62616162),
+	MKCOLOUR(0x62616261), // height 51
+	MKCOLOUR(0x62616261),
+	MKCOLOUR(0x62616262), // height 53
+	MKCOLOUR(0x62616262),
+	MKCOLOUR(0x62626161), // height 55
+	MKCOLOUR(0x62626161),
+	MKCOLOUR(0x62626162), // height 57
+	MKCOLOUR(0x62626162),
+	MKCOLOUR(0x62626261), // height 59
+	MKCOLOUR(0x62626261),
+	MKCOLOUR(0x62626262), // height 61 // original smallmap color do not modify
+	MKCOLOUR(0x62626262),
+	MKCOLOUR(0x62626263), // height 63
+	MKCOLOUR(0x62626263),
+	MKCOLOUR(0x62626362), // height 65
+	MKCOLOUR(0x62626362),
+	MKCOLOUR(0x62626363), // height 67
+	MKCOLOUR(0x62626363),
+	MKCOLOUR(0x62636262), // height 69
+	MKCOLOUR(0x62636262),
+	MKCOLOUR(0x62636263), // height 71 // original smallmap color do not modify
+	MKCOLOUR(0x62636263),
+	MKCOLOUR(0x62636362), // height 73
+	MKCOLOUR(0x62636362),
+	MKCOLOUR(0x62636363), // height 75
+	MKCOLOUR(0x62636363),
+	MKCOLOUR(0x63626262), // height 77
+	MKCOLOUR(0x63626262),
+	MKCOLOUR(0x63626263), // height 79
+	MKCOLOUR(0x63626263),
+	MKCOLOUR(0x63626362), // height 81
+	MKCOLOUR(0x63626362),
+	MKCOLOUR(0x63626363), // height 83
+	MKCOLOUR(0x63626363),
+	MKCOLOUR(0x63636262), // height 85
+	MKCOLOUR(0x63636262),
+	MKCOLOUR(0x63636263), // height 87
+	MKCOLOUR(0x63636263),
+	MKCOLOUR(0x63636362), // height 89
+	MKCOLOUR(0x63636362),
+	MKCOLOUR(0x63636363), // height 91 // original smallmap color do not modify
+	MKCOLOUR(0x63636363),
+	MKCOLOUR(0x63636364), // height 93
+	MKCOLOUR(0x63636364),
+	MKCOLOUR(0x63636463), // height 95
+	MKCOLOUR(0x63636463),
+	MKCOLOUR(0x63636464), // height 97
+	MKCOLOUR(0x63636464),
+	MKCOLOUR(0x63646363), // height 99
+	MKCOLOUR(0x63646363),
+	MKCOLOUR(0x63646364), // height 101 // original smallmap color do not modify
+	MKCOLOUR(0x63646364),
+	MKCOLOUR(0x63646463), // height 103
+	MKCOLOUR(0x63646463),
+	MKCOLOUR(0x63646464), // height 105
+	MKCOLOUR(0x63646464),
+	MKCOLOUR(0x64636363), // height 107
+	MKCOLOUR(0x64636363),
+	MKCOLOUR(0x64636364), // height 109
+	MKCOLOUR(0x64636364),
+	MKCOLOUR(0x64636463), // height 111
+	MKCOLOUR(0x64636463),
+	MKCOLOUR(0x64636464), // height 113
+	MKCOLOUR(0x64636464),
+	MKCOLOUR(0x64646363), // height 115
+	MKCOLOUR(0x64646363),
+	MKCOLOUR(0x64646364), // height 117
+	MKCOLOUR(0x64646364),
+	MKCOLOUR(0x64646463), // height 119
+	MKCOLOUR(0x64646463),
+	MKCOLOUR(0x64646464), // height 121 // original smallmap color do not modify
+	MKCOLOUR(0x64646464),
+	MKCOLOUR(0x64646465), // height 123
+	MKCOLOUR(0x64646465),
+	MKCOLOUR(0x64646564), // height 125
+	MKCOLOUR(0x64646564),
+	MKCOLOUR(0x64646565), // height 127
+	MKCOLOUR(0x64646565),
+	MKCOLOUR(0x64656464), // height 129
+	MKCOLOUR(0x64656464),
+	MKCOLOUR(0x64656465), // height 131 // original smallmap color do not modify
+	MKCOLOUR(0x64656465),
+	MKCOLOUR(0x64656564), // height 133
+	MKCOLOUR(0x64656564),
+	MKCOLOUR(0x64656565), // height 135
+	MKCOLOUR(0x64656565),
+	MKCOLOUR(0x65646464), // height 137
+	MKCOLOUR(0x65646464),
+	MKCOLOUR(0x65646465), // height 139
+	MKCOLOUR(0x65646465),
+	MKCOLOUR(0x65646564), // height 141
+	MKCOLOUR(0x65646564),
+	MKCOLOUR(0x65646565), // height 143
+	MKCOLOUR(0x65646565),
+	MKCOLOUR(0x65656464), // height 145
+	MKCOLOUR(0x65656464),
+	MKCOLOUR(0x65656465), // height 147
+	MKCOLOUR(0x65656465),
+	MKCOLOUR(0x65656564), // height 149
+	MKCOLOUR(0x65656564),
+	MKCOLOUR(0x65656565), // height 151 // original smallmap color do not modify
+	MKCOLOUR(0x65656565),
+	MKCOLOUR(0x65656566), // height 153
+	MKCOLOUR(0x65656566),
+	MKCOLOUR(0x65656665), // height 155
+	MKCOLOUR(0x65656665),
+	MKCOLOUR(0x65656666), // height 157
+	MKCOLOUR(0x65656666),
+	MKCOLOUR(0x65666565), // height 159
+	MKCOLOUR(0x65666565),
+	MKCOLOUR(0x65666566), // height 161 // original smallmap color do not modify
+	MKCOLOUR(0x65666566),
+	MKCOLOUR(0x65666665), // height 163
+	MKCOLOUR(0x65666665),
+	MKCOLOUR(0x65666666), // height 165
+	MKCOLOUR(0x65666666),
+	MKCOLOUR(0x66656565), // height 167
+	MKCOLOUR(0x66656565),
+	MKCOLOUR(0x66656566), // height 169
+	MKCOLOUR(0x66656566),
+	MKCOLOUR(0x66656665), // height 171
+	MKCOLOUR(0x66656665),
+	MKCOLOUR(0x66656666), // height 173
+	MKCOLOUR(0x66656666),
+	MKCOLOUR(0x66666565), // height 175
+	MKCOLOUR(0x66666565),
+	MKCOLOUR(0x66666566), // height 177
+	MKCOLOUR(0x66666566),
+	MKCOLOUR(0x66666665), // height 179
+	MKCOLOUR(0x66666665),
+	MKCOLOUR(0x66666666), // height 181 // original smallmap color do not modify
+	MKCOLOUR(0x66666666),
+	MKCOLOUR(0x66666667), // height 183
+	MKCOLOUR(0x66666667),
+	MKCOLOUR(0x66666766), // height 185
+	MKCOLOUR(0x66666766),
+	MKCOLOUR(0x66666767), // height 187
+	MKCOLOUR(0x66666767),
+	MKCOLOUR(0x66676666), // height 189
+	MKCOLOUR(0x66676666),
+	MKCOLOUR(0x66676667), // height 191 // original smallmap color do not modify
+	MKCOLOUR(0x66676667),
+	MKCOLOUR(0x66676766), // height 193
+	MKCOLOUR(0x66676766),
+	MKCOLOUR(0x66676767), // height 195
+	MKCOLOUR(0x66676767),
+	MKCOLOUR(0x67676767), // height 197 // original smallmap color do not modify
+	MKCOLOUR(0x67676767),
+
+// TODO: Extend. read: replace dummy (copied) colurs below
+
+//	MKCOLOUR(0x67676768), // browns or something do not use untill ...
+//	MKCOLOUR(0x67676868),
+//	MKCOLOUR(0x67686868),
+//	MKCOLOUR(0x68686868),
+//	MKCOLOUR(0x68686869),
+//	MKCOLOUR(0x69686869),
+//	MKCOLOUR(0x68686969),
+//	MKCOLOUR(0x68696969),
+//	MKCOLOUR(0x69696969),
+//	MKCOLOUR(0x6969696A),
+//	MKCOLOUR(0x69A96A6A),
+//	MKCOLOUR(0x6A6A6A6A),
+//	MKCOLOUR(0x6A6A6A6B),
+//	MKCOLOUR(0x6A6A6B6B),
+//	MKCOLOUR(0x6A6B6B6B),
+//	MKCOLOUR(0x6B6B6B6B), // ... here and probably a little further.
+
+	MKCOLOUR(0x67676767), // height 199
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 201
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 203
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 205
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 207
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 209
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 211
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 213
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 215
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 217
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 219
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 221
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 223
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 225
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 227
+	MKCOLOUR(0x67676767),
+	MKCOLOUR(0x67676767), // height 229
+	MKCOLOUR(0x67676767),
+
+// TODO: extend untill here
+
+	/* purple top */
+	MKCOLOUR(0x1F27AF27), // height 231
+	MKCOLOUR(0x1F27AF27), // height 232
+	MKCOLOUR(0x1F274FAF), // height 233
+	MKCOLOUR(0x1F274FAF), // height 234
+	MKCOLOUR(0x4F274FAF), // height 235
+	MKCOLOUR(0x4F274FAF), // height 236
+	MKCOLOUR(0x4FAF1FAF), // height 237
+	MKCOLOUR(0x4FAF1FAF), // height 238
+	MKCOLOUR(0x4F2727AF), // height 239
+	MKCOLOUR(0x4F2727AF), // height 240
+	MKCOLOUR(0x4F27AF27), // height 241
+	MKCOLOUR(0x4F27AF27), // height 242
+	MKCOLOUR(0x4F27AFAF), // height 243
+	MKCOLOUR(0x4F27AFAF), // height 244
+	MKCOLOUR(0x4FAF2727), // height 245
+	MKCOLOUR(0x4FAF2727), // height 246
+	MKCOLOUR(0x4FAF27AF), // height 247
+	MKCOLOUR(0x4FAF27AF), // height 248
+	MKCOLOUR(0x4FAFAF27), // height 249
+	MKCOLOUR(0x4FAFAF27), // height 250
+	MKCOLOUR(0x4FAFAFAF), // height 251
+	MKCOLOUR(0x4FAFAFAF), // height 252
+	MKCOLOUR(0x4FAFAFCF), // height 253
+	MKCOLOUR(0x4FAFAFCF), // height 254
+	MKCOLOUR(0x4FAFCFAF), // height 255
+	MKCOLOUR(0x4FCFAFAF), /* 1 extra color for people not liking the flood_warning feature. */
+	/* Flashing test with current parameters no longer needed. */
+	//MKCOLOUR(0x04dcdcdc), /* FLASHING TEST (You can use this when going for 512 colours.) */
+};
+assert_compile(lengthof(_dark_green_map_heights_extended) == MAX_TILE_HEIGHT_EXTENDED + 2);
+
+/**
+ * Height map colours for the violet colour scheme, ordered by height.
+ * This is the original array for use when AllowMoreHeightlevels() is false.
+ */
+static const uint32 _violet_map_heights_old[] = {
+	MKCOLOUR(0x04dcdcdc), // Action colour, flashing purple. This is for level zero(Not flooded) !! Flooding danger !! Not yet water. (When level -1 will be possible: Will provide for a nice flooding_danger_area_border_flash in combination witch previous colour, similar to the waves at water borders.)
 	MKCOLOUR_XXXX(0x80),
 	MKCOLOUR_XYXY(0x80, 0x81),
 	MKCOLOUR_XXXX(0x81),
@@ -298,19 +1011,341 @@
 	MKCOLOUR_XXXX(0x87),
 	MKCOLOUR_XXXX(0x87),
 };
-assert_compile(lengthof(_violet_map_heights) == MAX_TILE_HEIGHT + 1);
+assert_compile(lengthof(_violet_map_heights_old) == MAX_TILE_HEIGHT_OLD + 2);
+
+/**
+ * Height map colours for the violet colour scheme, ordered by height.
+ * Used when AllowMoreHeightlevels() is true.
+ * For the moment the aray is extended to 256 levels.
+ */
+static const uint32 _violet_map_heights_extended[] = {
+	/* First two colours are action colours.(First commented out, first we need level -1 (and underwater tunnels)) */
+	//MKCOLOUR(0xdcdcdcdc), // Nice flashy colour, darkblue. (Do not use above level 1. (second colour)) (I keep it here to become level -1 ground tile (not flooded) (For now: To see its full effect, use this as second color.Then imagine at level -1.))
+	MKCOLOUR(0x04dcdcdc), // Action colour, flashing purple. This is for level zero(Not flooded) !! Flooding danger !! Not yet water. (When level -1 will be possible: Will provide for a nice flooding_danger_area_border_flash in combination witch previous colour, similar to the waves at water borders.)
+	MKCOLOUR(0x80808080), // height 1 // original smallmap color do not modify
+	MKCOLOUR(0x80808080),
+	MKCOLOUR(0x80808081), // height 3
+	MKCOLOUR(0x80808081),
+	MKCOLOUR(0x80808180), // height 5
+	MKCOLOUR(0x80808180),
+	MKCOLOUR(0x80808181), // height 7
+	MKCOLOUR(0x80808181),
+	MKCOLOUR(0x80818080), // height 9
+	MKCOLOUR(0x80818080),
+	MKCOLOUR(0x80818081), // height 11 // original smallmap color do not modify
+	MKCOLOUR(0x80818081),
+	MKCOLOUR(0x80818180), // height 13
+	MKCOLOUR(0x80818180),
+	MKCOLOUR(0x80818181), // height 15
+	MKCOLOUR(0x80818181),
+	MKCOLOUR(0x81808080), // height 17
+	MKCOLOUR(0x81808080),
+	MKCOLOUR(0x81808081), // height 19
+	MKCOLOUR(0x81808081),
+	MKCOLOUR(0x81808180), // height 21
+	MKCOLOUR(0x81808180),
+	MKCOLOUR(0x81808181), // height 23
+	MKCOLOUR(0x81808181),
+	MKCOLOUR(0x81818080), // height 25
+	MKCOLOUR(0x81818080),
+	MKCOLOUR(0x81818081), // height 27
+	MKCOLOUR(0x81818081),
+	MKCOLOUR(0x81818180), // height 29
+	MKCOLOUR(0x81818180),
+	MKCOLOUR(0x81818181), // height 31 // original smallmap color do not modify
+	MKCOLOUR(0x81818181),
+	MKCOLOUR(0x81818182), // height 33
+	MKCOLOUR(0x81818182),
+	MKCOLOUR(0x81818281), // height 35
+	MKCOLOUR(0x81818281),
+	MKCOLOUR(0x81818282), // height 37
+	MKCOLOUR(0x81818282),
+	MKCOLOUR(0x81828181), // height 39
+	MKCOLOUR(0x81828181),
+	MKCOLOUR(0x81828182), // height 41 // original smallmap color do not modify
+	MKCOLOUR(0x81828182),
+	MKCOLOUR(0x81828281), // height 43
+	MKCOLOUR(0x81828281),
+	MKCOLOUR(0x81828282), // height 45
+	MKCOLOUR(0x81828282),
+	MKCOLOUR(0x82818181), // height 47
+	MKCOLOUR(0x82818181),
+	MKCOLOUR(0x82818182), // height 49
+	MKCOLOUR(0x82818182),
+	MKCOLOUR(0x82818281), // height 51
+	MKCOLOUR(0x82818281),
+	MKCOLOUR(0x82818282), // height 53
+	MKCOLOUR(0x82818282),
+	MKCOLOUR(0x82828181), // height 55
+	MKCOLOUR(0x82828181),
+	MKCOLOUR(0x82828182), // height 57
+	MKCOLOUR(0x82828182),
+	MKCOLOUR(0x82828281), // height 59
+	MKCOLOUR(0x82828281),
+	MKCOLOUR(0x82828282), // height 61 // original smallmap color do not modify
+	MKCOLOUR(0x82828282),
+	MKCOLOUR(0x82828283), // height 63
+	MKCOLOUR(0x82828283),
+	MKCOLOUR(0x82828382), // height 65
+	MKCOLOUR(0x82828382),
+	MKCOLOUR(0x82828383), // height 67
+	MKCOLOUR(0x82828383),
+	MKCOLOUR(0x82838282), // height 69
+	MKCOLOUR(0x82838282),
+	MKCOLOUR(0x82838283), // height 71 // original smallmap color do not modify
+	MKCOLOUR(0x82838283),
+	MKCOLOUR(0x82838382), // height 73
+	MKCOLOUR(0x82838382),
+	MKCOLOUR(0x82838383), // height 75
+	MKCOLOUR(0x82838383),
+	MKCOLOUR(0x83828282), // height 77
+	MKCOLOUR(0x83828282),
+	MKCOLOUR(0x83828283), // height 79
+	MKCOLOUR(0x83828283),
+	MKCOLOUR(0x83828382), // height 81
+	MKCOLOUR(0x83828382),
+	MKCOLOUR(0x83828383), // height 83
+	MKCOLOUR(0x83828383),
+	MKCOLOUR(0x83838282), // height 85
+	MKCOLOUR(0x83838282),
+	MKCOLOUR(0x83838283), // height 87
+	MKCOLOUR(0x83838283),
+	MKCOLOUR(0x83838382), // height 89
+	MKCOLOUR(0x83838382),
+	MKCOLOUR(0x83838383), // height 91 // original smallmap color do not modify
+	MKCOLOUR(0x83838383),
+	MKCOLOUR(0x83838384), // height 93
+	MKCOLOUR(0x83838384),
+	MKCOLOUR(0x83838483), // height 95
+	MKCOLOUR(0x83838483),
+	MKCOLOUR(0x83838484), // height 97
+	MKCOLOUR(0x83838484),
+	MKCOLOUR(0x83848383), // height 99
+	MKCOLOUR(0x83848383),
+	MKCOLOUR(0x83848384), // height 101 // original smallmap color do not modify
+	MKCOLOUR(0x83848384),
+	MKCOLOUR(0x83848483), // height 103
+	MKCOLOUR(0x83848483),
+	MKCOLOUR(0x83848484), // height 105
+	MKCOLOUR(0x83848484),
+	MKCOLOUR(0x84838383), // height 107
+	MKCOLOUR(0x84838383),
+	MKCOLOUR(0x84838384), // height 109
+	MKCOLOUR(0x84838384),
+	MKCOLOUR(0x84838483), // height 111
+	MKCOLOUR(0x84838483),
+	MKCOLOUR(0x84838484), // height 113
+	MKCOLOUR(0x84838484),
+	MKCOLOUR(0x84848383), // height 115
+	MKCOLOUR(0x84848383),
+	MKCOLOUR(0x84848384), // height 117
+	MKCOLOUR(0x84848384),
+	MKCOLOUR(0x84848483), // height 119
+	MKCOLOUR(0x84848483),
+	MKCOLOUR(0x84848484), // height 121 // original smallmap color do not modify
+	MKCOLOUR(0x84848484),
+	MKCOLOUR(0x84848485), // height 123
+	MKCOLOUR(0x84848485),
+	MKCOLOUR(0x84848584), // height 125
+	MKCOLOUR(0x84848584),
+	MKCOLOUR(0x84848585), // height 127
+	MKCOLOUR(0x84848585),
+	MKCOLOUR(0x84858484), // height 129
+	MKCOLOUR(0x84858484),
+	MKCOLOUR(0x84858485), // height 131 // original smallmap color do not modify
+	MKCOLOUR(0x84858485),
+	MKCOLOUR(0x84858584), // height 133
+	MKCOLOUR(0x84858584),
+	MKCOLOUR(0x84858585), // height 135
+	MKCOLOUR(0x84858585),
+	MKCOLOUR(0x85848484), // height 137
+	MKCOLOUR(0x85848484),
+	MKCOLOUR(0x85848485), // height 139
+	MKCOLOUR(0x85848485),
+	MKCOLOUR(0x85848584), // height 141
+	MKCOLOUR(0x85848584),
+	MKCOLOUR(0x85848585), // height 143
+	MKCOLOUR(0x85848585),
+	MKCOLOUR(0x85858484), // height 145
+	MKCOLOUR(0x85858484),
+	MKCOLOUR(0x85858485), // height 147
+	MKCOLOUR(0x85858485),
+	MKCOLOUR(0x85858584), // height 149
+	MKCOLOUR(0x85858584),
+	MKCOLOUR(0x85858585), // height 151 // original smallmap color do not modify
+	MKCOLOUR(0x85858585),
+	MKCOLOUR(0x85858586), // height 153
+	MKCOLOUR(0x85858586),
+	MKCOLOUR(0x85858685), // height 155
+	MKCOLOUR(0x85858685),
+	MKCOLOUR(0x85858686), // height 157
+	MKCOLOUR(0x85858686),
+	MKCOLOUR(0x85868585), // height 159
+	MKCOLOUR(0x85868585),
+	MKCOLOUR(0x85868586), // height 161 // original smallmap color do not modify
+	MKCOLOUR(0x85868586),
+	MKCOLOUR(0x85868685), // height 163
+	MKCOLOUR(0x85868685),
+	MKCOLOUR(0x85868686), // height 165
+	MKCOLOUR(0x85868686),
+	MKCOLOUR(0x85868585), // height 167
+	MKCOLOUR(0x85868585),
+	MKCOLOUR(0x85868586), // height 169
+	MKCOLOUR(0x85868586),
+	MKCOLOUR(0x85868685), // height 171
+	MKCOLOUR(0x85868685),
+	MKCOLOUR(0x85868686), // height 173
+	MKCOLOUR(0x85868686),
+	MKCOLOUR(0x86868585), // height 175
+	MKCOLOUR(0x86868585),
+	MKCOLOUR(0x86868586), // height 177
+	MKCOLOUR(0x86868586),
+	MKCOLOUR(0x86868685), // height 179
+	MKCOLOUR(0x86868685),
+	MKCOLOUR(0x86868686), // height 181 // original smallmap color do not modify
+	MKCOLOUR(0x86868686),
+	MKCOLOUR(0x86868687), // height 183
+	MKCOLOUR(0x86868687),
+	MKCOLOUR(0x86868786), // height 185
+	MKCOLOUR(0x86868786),
+	MKCOLOUR(0x86868787), // height 187
+	MKCOLOUR(0x86868787),
+	MKCOLOUR(0x86878686), // height 189
+	MKCOLOUR(0x86878686),
+	MKCOLOUR(0x86878687), // height 191 // original smallmap color do not modify
+	MKCOLOUR(0x86878687),
+	MKCOLOUR(0x86878786), // height 193
+	MKCOLOUR(0x86878786),
+	MKCOLOUR(0x86878787), // height 195
+	MKCOLOUR(0x86878787),
+	MKCOLOUR(0x87868686), // height 197
+	MKCOLOUR(0x87868686),
+	MKCOLOUR(0x87868687), // height 199
+	MKCOLOUR(0x87868687),
+	MKCOLOUR(0x87868786), // height 201
+	MKCOLOUR(0x87868786),
+	MKCOLOUR(0x87868787), // height 203
+	MKCOLOUR(0x87868787),
+	MKCOLOUR(0x87878686), // height 205
+	MKCOLOUR(0x87878686),
+	MKCOLOUR(0x87878687), // height 207
+	MKCOLOUR(0x87878687),
+	MKCOLOUR(0x87878786), // height 209
+	MKCOLOUR(0x87878786),
+	MKCOLOUR(0x87878787), // height 211 // original smallmap color do not modify
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 213 // original smallmap color do not modify
+	MKCOLOUR(0x87878787),
+
+// TODO: Extend. read: replace dummy (copied) colurs below
+
+//	MKCOLOUR(0x87878788), // don't use greys/blacks
+//	MKCOLOUR(0x87878788),
+//	MKCOLOUR(0x87878887),
+//	MKCOLOUR(0x87878887),
+//	MKCOLOUR(0x87878888),
+//	MKCOLOUR(0x87878888),
+//	MKCOLOUR(0x87888787),
+//	MKCOLOUR(0x87888787),
+//	MKCOLOUR(0x87888788),
+//	MKCOLOUR(0x87888788),
+//	MKCOLOUR(0x87888887),
+//	MKCOLOUR(0x87888887),
+//	MKCOLOUR(0x87888888),
+//	MKCOLOUR(0x87888888),
+//	MKCOLOUR(0x88878787),
+//	MKCOLOUR(0x88878788),
+//	MKCOLOUR(0x88878887),
+//	MKCOLOUR(0x88878888),
+//	MKCOLOUR(0x88888787),
+//	MKCOLOUR(0x88888788),
+//	MKCOLOUR(0x88888887),
+//	MKCOLOUR(0x88888888), // dont't use untill here probaby a little further too
+
+	MKCOLOUR(0x87878787), // height 215
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 217
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 219
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 221
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 223
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 225
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 227
+	MKCOLOUR(0x87878787),
+	MKCOLOUR(0x87878787), // height 229
+	MKCOLOUR(0x87878787),
+
+// TODO: extend untill here
+
+	/* purple top */
+	MKCOLOUR(0x1F27AF27), // height 231
+	MKCOLOUR(0x1F27AF27), // height 232
+	MKCOLOUR(0x1F274FAF), // height 233
+	MKCOLOUR(0x1F274FAF), // height 234
+	MKCOLOUR(0x4F274FAF), // height 235
+	MKCOLOUR(0x4F274FAF), // height 236
+	MKCOLOUR(0x4FAF1FAF), // height 237
+	MKCOLOUR(0x4FAF1FAF), // height 238
+	MKCOLOUR(0x4F2727AF), // height 239
+	MKCOLOUR(0x4F2727AF), // height 240
+	MKCOLOUR(0x4F27AF27), // height 241
+	MKCOLOUR(0x4F27AF27), // height 242
+	MKCOLOUR(0x4F27AFAF), // height 243
+	MKCOLOUR(0x4F27AFAF), // height 244
+	MKCOLOUR(0x4FAF2727), // height 245
+	MKCOLOUR(0x4FAF2727), // height 246
+	MKCOLOUR(0x4FAF27AF), // height 247
+	MKCOLOUR(0x4FAF27AF), // height 248
+	MKCOLOUR(0x4FAFAF27), // height 249
+	MKCOLOUR(0x4FAFAF27), // height 250
+	MKCOLOUR(0x4FAFAFAF), // height 251
+	MKCOLOUR(0x4FAFAFAF), // height 252
+	MKCOLOUR(0x4FAFAFCF), // height 253
+	MKCOLOUR(0x4FAFAFCF), // height 254
+	MKCOLOUR(0x4FAFCFAF), // height 255
+	MKCOLOUR(0x4FCFAFAF), /* 1 extra color for people not liking the flood_warning feature. */
+	/* Flashing test with current parameters no longer needed. */
+	//MKCOLOUR(0x04dcdcdc), /* FLASHING TEST (You can use this when going for 512 colours.) */
+};
+assert_compile(lengthof(_violet_map_heights_extended) == MAX_TILE_HEIGHT_EXTENDED + 2);
+
+/**
+ * Colour Coding for Stuck Counter
+ */
+static const uint32 _stuck_counter_colours[] = {
+	MKCOLOUR(0xD0D0D0D0),
+	MKCOLOUR(0xCECECECE),
+	MKCOLOUR(0xBFBFBFBF),
+	MKCOLOUR(0xBDBDBDBD),
+	MKCOLOUR(0xBABABABA),
+	MKCOLOUR(0xB8B8B8B8),
+	MKCOLOUR(0xB6B6B6B6),
+	MKCOLOUR(0xB4B4B4B4),
+};
+assert_compile(lengthof(_stuck_counter_colours) == 8);
 
 /** Colour scheme of the smallmap. */
 struct SmallMapColourScheme {
 	const uint32 *height_colours; ///< Colour of each level in a heightmap.
-	uint32 default_colour;   ///< Default colour of the land.
+	uint32 default_colour;        ///< Default colour of the land.
 };
 
-/** Available colour schemes for height maps. */
-static const SmallMapColourScheme _heightmap_schemes[] = {
-	{_green_map_heights,      MKCOLOUR_XXXX(0x54)}, ///< Green colour scheme.
-	{_dark_green_map_heights, MKCOLOUR_XXXX(0x62)}, ///< Dark green colour scheme.
-	{_violet_map_heights,     MKCOLOUR_XXXX(0x82)}, ///< Violet colour scheme.
+/** Available colour schemes for height maps. (original) */
+static const SmallMapColourScheme _heightmap_schemes_old[] = {
+	{_green_map_heights_old,      MKCOLOUR_XXXX(0x54)}, ///< Green colour scheme.
+	{_dark_green_map_heights_old, MKCOLOUR_XXXX(0x62)}, ///< Dark green colour scheme.
+	{_violet_map_heights_old,     MKCOLOUR_XXXX(0x82)}, ///< Violet colour scheme.
+};
+
+/** Available colour schemes for height maps. (in case of AllowMoreHeightlevels() ) */
+static const SmallMapColourScheme _heightmap_schemes_extended[] = {
+	{_green_map_heights_extended,      MKCOLOUR(0x54545454)}, ///< Green colour scheme.
+	{_dark_green_map_heights_extended, MKCOLOUR(0x62626262)}, ///< Dark green colour scheme.
+	{_violet_map_heights_extended,     MKCOLOUR(0x82828282)}, ///< Violet colour scheme.
 };
 
 /**
@@ -318,8 +1353,14 @@
  */
 void BuildLandLegend()
 {
-	for (LegendAndColour *lc = _legend_land_contours; lc->legend == STR_TINY_BLACK_HEIGHT; lc++) {
-		lc->colour = _heightmap_schemes[_settings_client.gui.smallmap_land_colour].height_colours[lc->height];
+	if (AllowMoreHeightlevels()) {
+		for (LegendAndColour *lc = _legend_land_contours_extended; lc->legend == STR_TINY_BLACK_HEIGHT; lc++) {
+			lc->colour = _heightmap_schemes_extended[_settings_client.gui.smallmap_land_colour].height_colours[lc->height];
+		}
+	} else {
+		for (LegendAndColour *lc = _legend_land_contours_old; lc->legend == STR_TINY_BLACK_HEIGHT; lc++) {
+			lc->colour = _heightmap_schemes_old[_settings_client.gui.smallmap_land_colour].height_colours[lc->height];
+		}
 	}
 }
 
@@ -328,7 +1369,11 @@
  */
 void BuildOwnerLegend()
 {
-	_legend_land_owners[1].colour = _heightmap_schemes[_settings_client.gui.smallmap_land_colour].default_colour;
+	if (AllowMoreHeightlevels()) {
+		_legend_land_owners[1].colour = _heightmap_schemes_extended[_settings_client.gui.smallmap_land_colour].default_colour;
+	} else {
+		_legend_land_owners[1].colour = _heightmap_schemes_old[_settings_client.gui.smallmap_land_colour].default_colour;
+	}
 
 	int i = NUM_NO_COMPANY_ENTRIES;
 	const Company *c;
@@ -359,7 +1404,6 @@
 	return (colour & mask->mand) | mask->mor;
 }
 
-
 /** Colour masks for "Contour" and "Routes" modes. */
 static const AndOr _smallmap_contours_andor[] = {
 	{MKCOLOUR_0000               , MKCOLOUR_FFFF}, // MP_CLEAR
@@ -433,8 +1477,51 @@
  */
 static inline uint32 GetSmallMapContoursPixels(TileIndex tile, TileType t)
 {
-	const SmallMapColourScheme *cs = &_heightmap_schemes[_settings_client.gui.smallmap_land_colour];
-	return ApplyMask(cs->height_colours[TileHeight(tile)], &_smallmap_contours_andor[t]);
+	uint tile_height = TileHeight(tile);
+
+	if (_settings_client.gui.smallmap_land_colour == 0) {
+		if (AllowMoreHeightlevels()) {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_green_map_heights_extended[tile_height], &_smallmap_contours_andor[t]);
+			} else {
+				return ApplyMask(_green_map_heights_extended[tile_height + 1], &_smallmap_contours_andor[t]);
+			}
+		} else {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_green_map_heights_old[tile_height], &_smallmap_contours_andor[t]);
+			} else {
+				return ApplyMask(_green_map_heights_old[tile_height + 1], &_smallmap_contours_andor[t]);
+			}
+		}
+	} else if (_settings_client.gui.smallmap_land_colour == 1) {
+		if (AllowMoreHeightlevels()) {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_dark_green_map_heights_extended[tile_height], &_smallmap_contours_andor[t]);
+			} else {
+				return ApplyMask(_dark_green_map_heights_extended[tile_height + 1], &_smallmap_contours_andor[t]);
+			}
+		} else {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_dark_green_map_heights_old[tile_height], &_smallmap_contours_andor[t]);
+			} else {
+				return ApplyMask(_dark_green_map_heights_old[tile_height + 1], &_smallmap_contours_andor[t]);
+			}
+		}
+	} else {
+		if (AllowMoreHeightlevels()) {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_violet_map_heights_extended[tile_height], &_smallmap_contours_andor[t]);
+			} else {
+				return ApplyMask(_violet_map_heights_extended[tile_height + 1], &_smallmap_contours_andor[t]);
+			}
+		} else {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_violet_map_heights_old[tile_height], &_smallmap_contours_andor[t]);
+			} else {
+				return ApplyMask(_violet_map_heights_old[tile_height + 1], &_smallmap_contours_andor[t]);
+			}
+		}
+	}
 }
 
 /**
@@ -446,8 +1533,13 @@
  */
 static inline uint32 GetSmallMapVehiclesPixels(TileIndex tile, TileType t)
 {
-	const SmallMapColourScheme *cs = &_heightmap_schemes[_settings_client.gui.smallmap_land_colour];
-	return ApplyMask(cs->default_colour, &_smallmap_vehicles_andor[t]);
+	if (AllowMoreHeightlevels()) {
+		const SmallMapColourScheme *cs = &_heightmap_schemes_extended[_settings_client.gui.smallmap_land_colour];
+		return ApplyMask(cs->default_colour, &_smallmap_vehicles_andor[t]);
+	} else {
+		const SmallMapColourScheme *cs = &_heightmap_schemes_old[_settings_client.gui.smallmap_land_colour];
+		return ApplyMask(cs->default_colour, &_smallmap_vehicles_andor[t]);
+	}
 }
 
 /**
@@ -469,8 +1561,49 @@
 		}
 	}
 
-	const SmallMapColourScheme *cs = &_heightmap_schemes[_settings_client.gui.smallmap_land_colour];
-	return ApplyMask(_smallmap_show_heightmap ? cs->height_colours[TileHeight(tile)] : cs->default_colour, &_smallmap_vehicles_andor[t]);
+	if (_settings_client.gui.smallmap_land_colour == 0) {
+		if (AllowMoreHeightlevels()) {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_smallmap_show_heightmap ? _green_map_heights_extended[TileHeight(tile)] : MKCOLOUR(0x54545454), &_smallmap_vehicles_andor[t]);
+			} else {
+				return ApplyMask(_smallmap_show_heightmap ? _green_map_heights_extended[TileHeight(tile) + 1] : MKCOLOUR(0x54545454), &_smallmap_vehicles_andor[t]);
+			}
+		} else {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_smallmap_show_heightmap ? _green_map_heights_old[TileHeight(tile)] : MKCOLOUR(0x54545454), &_smallmap_vehicles_andor[t]);
+			} else {
+				return ApplyMask(_smallmap_show_heightmap ? _green_map_heights_old[TileHeight(tile) + 1] : MKCOLOUR(0x54545454), &_smallmap_vehicles_andor[t]);
+			}
+		}
+	} else if (_settings_client.gui.smallmap_land_colour == 1) {
+		if (AllowMoreHeightlevels()) {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_smallmap_show_heightmap ? _dark_green_map_heights_extended[TileHeight(tile)] : MKCOLOUR(0x62626262), &_smallmap_vehicles_andor[t]);
+			} else {
+				return ApplyMask(_smallmap_show_heightmap ? _dark_green_map_heights_extended[TileHeight(tile) + 1] : MKCOLOUR(0x62626262), &_smallmap_vehicles_andor[t]);
+			}
+		} else {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_smallmap_show_heightmap ? _dark_green_map_heights_old[TileHeight(tile)] : MKCOLOUR(0x62626262), &_smallmap_vehicles_andor[t]);
+			} else {
+				return ApplyMask(_smallmap_show_heightmap ? _dark_green_map_heights_old[TileHeight(tile) + 1] : MKCOLOUR(0x62626262), &_smallmap_vehicles_andor[t]);
+			}
+		}
+	} else {
+		if (AllowMoreHeightlevels()) {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_smallmap_show_heightmap ? _violet_map_heights_extended[TileHeight(tile)] : MKCOLOUR(0x82828282), &_smallmap_vehicles_andor[t]);
+			} else {
+				return ApplyMask(_smallmap_show_heightmap ? _violet_map_heights_extended[TileHeight(tile) + 1] : MKCOLOUR(0x82828282), &_smallmap_vehicles_andor[t]);
+			}
+		} else {
+			if(_settings_client.gui.smallmap_flood_warning) {
+				return ApplyMask(_smallmap_show_heightmap ? _violet_map_heights_old[TileHeight(tile)] : MKCOLOUR(0x82828282), &_smallmap_vehicles_andor[t]);
+			} else {
+				return ApplyMask(_smallmap_show_heightmap ? _violet_map_heights_old[TileHeight(tile) + 1] : MKCOLOUR(0x82828282), &_smallmap_vehicles_andor[t]);
+			}
+		}
+	}
 }
 
 /**
